Name: libgcc
Version     : 6.3.0
Release: 1
%define toolbox_release 1
%if 0%{?ibmi_version} < 72
%define aix_version 6.1
%else
%define aix_version 7.1
%endif
Group       : Development/Libraries
License     : GPL
URL         : http://gcc.gnu.org/
Summary     : GCC version %{version} shared support library

BuildRequires: cpio-gnu
BuildRequires: ibm-build-tools

Source0: https://public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc-%{aix_version}/gcc/libgcc-%{version}-%{toolbox_release}.aix%{aix_version}.ppc.rpm

%description
This package contains GCC shared support library which is needed
e.g. for exception handling support.

%package aix
Summary: AIX Toolbox GCC compatibility libraries
BuildArch: fat

%description aix
Provides libgcc_s.a and libatomic.a

%package -n libgcc_s1
Summary: GCC support library

%description -n libgcc_s1
Provides libgcc_s.so.1

%package -n libatomic1
Summary: GCC support library

%description -n libatomic1
Provides libatomic.so.1

%install

mkdir -p %{buildroot}/tmp
cd %{buildroot}/tmp

rpm2cpio %{SOURCE0} | cpio -idmv

mkdir -p %{buildroot}/%{_libdir}
cd %{buildroot}/%{_libdir}

mkdir 32 64
cd 32
    ar -X32 x %{buildroot}/tmp/opt/freeware/lib/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/pthread/libgcc_s.a
    fix-rpath shr.o %{_libdir}:/QOpenSys/usr/lib
    
    ar -X32 x %{buildroot}/tmp/opt/freeware/lib/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/pthread/libatomic.a
    fix-rpath libatomic.so.1 %{_libdir}:/QOpenSys/usr/lib
cd ../64
    ar -X64 x %{buildroot}/tmp/opt/freeware/lib/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/pthread/libgcc_s.a
    fix-rpath shr.o %{_libdir}:/QOpenSys/usr/lib
    
    ar -X64 x %{buildroot}/tmp/opt/freeware/lib/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/pthread/libatomic.a
    fix-rpath libatomic.so.1 %{_libdir}:/QOpenSys/usr/lib
cd ..

cp 64/shr.o libgcc_s.so.1
svr4-shrlib libgcc_s.so.1 libgcc_s.so.1 ppc64

cp 64/libatomic.so.1 .
svr4-shrlib libatomic.so.1 libatomic.so.1 ppc64

strip -X32 -e 32/shr.o
strip -X64 -e 64/shr.o
ar -X32_64 crlo libgcc_s.a 32/shr.o 64/shr.o

strip -X32 -e 32/libatomic.so.1
strip -X64 -e 64/libatomic.so.1
ar -X32_64 crlo libatomic.a 32/libatomic.so.1 64/libatomic.so.1

rm -r 32 64

cd %{buildroot}
rm -r %{buildroot}/tmp

%files aix
%defattr(-, qsys, *none)

%{_libdir}/libgcc_s.a
%{_libdir}/libatomic.a

%files -n libgcc_s1
%defattr(-, qsys, *none)

%{_libdir}/libgcc_s.so.1

%files -n libatomic1
%defattr(-, qsys, *none)

%{_libdir}/libatomic.so.1
